package com.zhongzheng.modules.bank.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.common.utils.ServletUtils;
import com.zhongzheng.modules.bank.bo.*;
import com.zhongzheng.modules.bank.domain.Exam;
import com.zhongzheng.modules.bank.domain.ExamQuestion;
import com.zhongzheng.modules.bank.domain.QuestionBusiness;
import com.zhongzheng.modules.bank.mapper.ExamMapper;
import com.zhongzheng.modules.bank.service.IExamQuestionService;
import com.zhongzheng.modules.bank.service.IExamService;
import com.zhongzheng.modules.bank.service.IQuestionBusinessService;
import com.zhongzheng.modules.bank.vo.ExamVo;
import com.zhongzheng.modules.course.bo.CourseChapterSectionListAddBo;
import com.zhongzheng.modules.course.domain.CourseChapterSection;
import com.zhongzheng.modules.course.service.ICourseChapterBusinessService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import org.springframework.transaction.annotation.Transactional;

import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 试卷Service业务层处理
 *
 * @author hjl
 * @date 2021-10-22
 */
@Service
public class ExamServiceImpl extends ServiceImpl<ExamMapper, Exam> implements IExamService {

    @Autowired
    private IExamQuestionService iExamQuestionService;

    @Autowired
    private IQuestionBusinessService iQuestionBusinessService;

    @Autowired
    private ExamMapper examMapper;

    @Override
    public ExamVo queryById(Long examId){
        Exam db = this.baseMapper.selectById(examId);
        return BeanUtil.toBean(db, ExamVo.class);
    }

    @Override
    public List<ExamVo> getList(ExamQueryBo bo) {
        return examMapper.getList(bo);
    }

    @Override
    public List<ExamVo> queryList(ExamQueryBo bo) {
        LambdaQueryWrapper<Exam> lqw = Wrappers.lambdaQuery();
        lqw.in(bo.getStatus() != null, Exam::getStatus, bo.getStatus());
        lqw.like(StrUtil.isNotBlank(bo.getPrefixName()), Exam::getPrefixName, bo.getPrefixName());
        lqw.eq(StrUtil.isNotBlank(bo.getCode()), Exam::getCode, bo.getCode());
        lqw.like(StrUtil.isNotBlank(bo.getExamName()), Exam::getExamName, bo.getExamName());
        lqw.eq(bo.getPublishStatus() != null, Exam::getPublishStatus, bo.getPublishStatus());
        lqw.eq(bo.getYear() != null, Exam::getYear, bo.getYear());
        lqw.eq(bo.getCityId() != null, Exam::getCityId, bo.getCityId());
        lqw.eq(bo.getProvinceId() != null, Exam::getProvinceId, bo.getProvinceId());
        lqw.eq(bo.getExamPaperId() != null, Exam::getExamPaperId, bo.getExamPaperId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ExamVo> entity2Vo(Collection<Exam> collection) {
        List<ExamVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ExamVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<Exam> page = (Page<Exam>)collection;
            Page<ExamVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean insertByAddBo(ExamAddBo bo) {
        Exam add = BeanUtil.toBean(bo, Exam.class);
        add.setCode(ServletUtils.getEncoded("SJ"));
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        boolean result = this.save(add);
        if(bo.getQuestionList()!=null){
            Collection<ExamQuestion> coll = new HashSet<>();
            for(int i=0;i<bo.getQuestionList().size();i++){
                ExamQuestionAddBo item = bo.getQuestionList().get(i);
                ExamQuestion addItem = new ExamQuestion();
                addItem.setExamId(add.getExamId());
                addItem.setQuestionId(item.getQuestionId());
                addItem.setSort(item.getSort());
                coll.add(addItem);

            }
            iExamQuestionService.saveBatch(coll);
        }
        if(bo.getBusinessList()!=null){
            Collection<QuestionBusiness> coll = new HashSet<>();
            for(int i=0;i<bo.getBusinessList().size();i++){
                QuestionBusinessAddBo item = bo.getBusinessList().get(i);
                QuestionBusiness addItem = BeanUtil.toBean(item, QuestionBusiness.class);
                addItem.setMajorId(add.getExamId());
                addItem.setType(QuestionBusiness.TYPE_EXAM);
                coll.add(addItem);
            }
            iQuestionBusinessService.saveBatch(coll);
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean updateByEditBo(ExamEditBo bo) {
        Exam update = BeanUtil.toBean(bo, Exam.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        if(bo.getQuestionList()!=null){
            Collection<ExamQuestion> coll = new HashSet<>();
            iExamQuestionService.remove(new LambdaQueryWrapper<ExamQuestion>().eq(ExamQuestion::getExamId, bo.getExamId()));
            for(int i=0;i<bo.getQuestionList().size();i++){
                ExamQuestionAddBo item = bo.getQuestionList().get(i);
                ExamQuestion addItem = BeanUtil.toBean(item, ExamQuestion.class);
                addItem.setExamId(update.getExamId());
                addItem.setQuestionId(item.getQuestionId());
                addItem.setSort(item.getSort());
                coll.add(addItem);
            }
            iExamQuestionService.saveBatch(coll);
        }
        if(bo.getBusinessList()!=null){
            iQuestionBusinessService.remove(new LambdaQueryWrapper<QuestionBusiness>()
                    .eq(QuestionBusiness::getMajorId, bo.getExamId())
                    .eq(QuestionBusiness::getType,QuestionBusiness.TYPE_EXAM));
            Collection<QuestionBusiness> coll = new HashSet<>();
            for(int i=0;i<bo.getBusinessList().size();i++){
                QuestionBusinessEditBo item = bo.getBusinessList().get(i);
                QuestionBusiness addItem = BeanUtil.toBean(item, QuestionBusiness.class);
                addItem.setMajorId(bo.getExamId());
                addItem.setType(QuestionBusiness.TYPE_EXAM);
                coll.add(addItem);
            }
            iQuestionBusinessService.saveBatch(coll);
        }
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(Exam entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
